# std::multimap::erase

From cppreference.com
< cpp‎ | container‎ | multimap

| (1) |
void erase( iterator pos ); |  | (until C++11)
iterator erase( const_iterator pos ); |  | (since C++11)
iterator erase( iterator pos ); |  | (since C++17)
| (2) |
void erase( iterator first, iterator last ); |  | (until C++11)
iterator erase( const_iterator first, const_iterator last ); |  | (since C++11)
size_type erase( const key_type& key ); | (3) |

Removes specified elements from the container.

1) Removes the element at `pos`.
2) Removes the elements in the range `[first; last)`, which must be a valid range in *this.
3) Removes all elements with the key equivalent to `key`.

References and iterators to the erased elements are invalidated. Other references and iterators are not affected.

The iterator `pos` must be valid and dereferenceable. Thus the end() iterator (which is valid, but is not dereferencable) cannot be used as a value for `pos`.

### Parameters

pos | - | iterator to the element to remove
first, last | - | range of elements to remove
key | - | key value of the elements to remove

### Return value

1-2) Iterator following the last removed element.
3) Number of elements removed.

### Exceptions

1,2) (none)
3) Any exceptions thrown by the `Compare` object.

### Complexity

Given an instance `c` of `multimap`:

1) Amortized constant
2) log(c.size()) + std::distance(first, last)
3) log(c.size()) + c.count(k)

### Example

Run this code

    #include <map>
    #include <iostream>
    int main()
    {
        std::multimap<int, std::string> c = {{1, "one"}, {2, "two"}, {3, "three"},
                                        {4, "four"}, {5, "five"}, {6, "six"}};
        // erase all odd numbers from c
        for(auto it = c.begin(); it != c.end(); )
            if(it->first % 2 == 1)
                it = c.erase(it);
            else
                ++it;
        for(auto& p : c)
            std::cout << p.second << ' ';
    }

Output:

    two four six

### See also

clear | clears the contents (public member function)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/container/multimap/erase&oldid=50583"